# find-cycles-in-dot

This is mere packaging for the tool found at https://gitlab.kitware.com/cmake/cmake/-/issues/21347 .

## Using this program to diagnose dependency cycles in a systemd setup

Run the following program chain:

```
# Plot all units involved in the cycle.
systemd-analyze verify default.target |& \
  tee /dev/stderr | \
  perl -lne 'print $1 if m{Found.*?on\s+([^/]+)}' | \
  xargs --no-run-if-empty systemd-analyze dot --order > \
  systemd.dot

# Augment the plot with cycle groupings.
find-cycles-in-dot systemd.dot withcycles.dot

# Convert the plot to a PDF plot of the graph.
dot -Tpdf < withcycles.dot > withcycles.pdf
```
